import { EventEmitter, ElementRef, Renderer2, ViewChild, Output, Input, Component, forwardRef, NgModule } from '@angular/core';
import { NG_VALUE_ACCESSOR, NG_VALIDATORS, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { MultiLingualData } from '@rxweb/localization';
import { CommonModule } from '@angular/common';
import { RxHttp } from '@rxweb/http';

var RandomNumber = /** @class */ (function () {
    function RandomNumber() {
    }
    RandomNumber.next = function () {
        RandomNumber.numberCount = RandomNumber.numberCount + 1;
        return RandomNumber.numberCount;
    };
    RandomNumber.numberCount = 10000;
    return RandomNumber;
}());

var TagModel = /** @class */ (function () {
    function TagModel(id, text, active, isRecordInvactive) {
        if (isRecordInvactive === void 0) { isRecordInvactive = false; }
        this.id = id;
        this.text = text;
        this.active = active;
        this.isRecordInvactive = isRecordInvactive;
    }
    return TagModel;
}());

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var RxTagComponent = /** @class */ (function (_super) {
    __extends(RxTagComponent, _super);
    function RxTagComponent(elementRef, renderer) {
        var _this = _super.call(this) || this;
        _this.elementRef = elementRef;
        _this.renderer = renderer;
        _this.propagateChange = function () { };
        _this.dropIndex = 0;
        _this.inputDisabled = false;
        _this.isLimitExceeded = false;
        _this.isInValid = false;
        _this.isCalledFromWriteValue = false;
        _this.isSpinner = false;
        _this.isServerCalled = false;
        _this.removed = new EventEmitter();
        _this.added = new EventEmitter();
        _this.autoComplete = false;
        _this.focus = false;
        _this.isObjectChanged = false;
        _this.mainSource = new Array();
        _this.selectedTags = new Array();
        _this.dropSource = new Array();
        _this.inActiveSource = new Array();
        _this.maxSelectionMessage = MultiLingualData.get("global.control.rx-tag.message-max-selection");
        _this.splitCharacter = MultiLingualData.get("global.control.rx-tag.split-character");
        var sortConfiguration = MultiLingualData.get("global.control.rx-tag.is-sort");
        _this.isSort = (sortConfiguration === '') ? _this.isSort : sortConfiguration;
        _this.placeholder = _this.placeholder || MultiLingualData.get("global.control.rx-tag.placeholder");
        _this.placeholder = _this.placeholder || "";
        if (!_this.splitCharacter)
            _this.splitCharacter = ",";
        _this.element = elementRef.nativeElement;
        _this.selectId = RandomNumber.next();
        _this.searchId = RandomNumber.next();
        return _this;
    }
    RxTagComponent_1 = RxTagComponent;
    Object.defineProperty(RxTagComponent.prototype, "source", {
        set: function (value) {
            if (value) {
                this.userSource = value;
                if (this.keyValueProps) {
                    var source = this.onlySelectedValueSource ? this.getSelectedTags(this.userSource, this.currentValue) : this.userSource;
                    this.setMainSource(source);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RxTagComponent.prototype, "text", {
        set: function (value) {
            if (value) {
                if (this.selectSearch && this.selectSearch.nativeElement)
                    this.selectSearch.nativeElement.value = value;
                this.controlText = value;
                this.currentValue = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    RxTagComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        if (this.formControl)
            this.writeValue(this.formControl.value, true);
        this.checkValid(true);
        if (this.userSource && this.mainSource.length === 0) {
            this.setMainSource(this.userSource);
            if (this.currentValue !== undefined && this.currentValue !== "")
                this.setSelectedTags(this.mainSource, this.currentValue);
        }
        else if (this.itemTexts && (this.currentValue !== undefined && this.currentValue !== "")) {
            var selectedItemSource = [];
            var splitIds = String(this.currentValue).split(this.splitCharacter);
            this.itemTexts.split(this.splitCharacter).forEach(function (t, i) {
                var jObject = {};
                jObject[_this.keyValueProps[1]] = splitIds[i];
                var textPattern = _this.keyValueProps[0].split(/#/g);
                jObject[textPattern[0]] = t;
                selectedItemSource.push(jObject);
            });
            var itemSource = this.getTagModelSource(selectedItemSource);
            if (this.currentValue)
                this.setSelectedTags(itemSource, this.currentValue);
        }
    };
    RxTagComponent.prototype.ngOnChanges = function (source) {
        var _this = this;
        if (source.params || source.queryParams) {
            this.isObjectChanged = true;
            this.clear();
        }
        if (this.focus)
            var t = setTimeout(function () {
                _this.applyFocus(_this.selectSearch.nativeElement);
            }, 1000);
    };
    RxTagComponent.prototype.checkValid = function (isValid) {
        var _this = this;
        if (isValid)
            this.validTimeOutId = window.setTimeout(function () {
                for (var i = 0; i < _this.element.classList.length; i++) {
                    _this.isInValid = _this.element.classList[i] == "ng-invalid";
                    if (_this.isInValid)
                        break;
                }
                window.clearTimeout(_this.validTimeOutId);
                _this.validTimeOutId = undefined;
            }, 500);
        else
            this.isInValid = isValid;
    };
    RxTagComponent.prototype.setMainSource = function (source) {
        var _this = this;
        this.inActiveSource = new Array();
        var mainSource = this.getTagModelSource(source);
        if (this.onlySelectedValueSource)
            mainSource = this.getSelectedTags(this.userSource, this.currentValue);
        this.mainSource = mainSource;
        this.mainSource.forEach(function (t) {
            return _this.dropSource.push(t);
        });
        this.sortSource();
    };
    RxTagComponent.prototype.sortSource = function () {
        this.dropSource = this.isSort === undefined || this.isSort === true || String(this.isSort) == "true" ? this.dropSource.sort(this.customSort(function (t) { return t.text; }, false)) : this.dropSource;
    };
    RxTagComponent.prototype.customSort = function (predicate, orderByDescending) {
        return function (a, b) {
            var first = predicate(a);
            var second = predicate(b);
            if (first > second) {
                return !orderByDescending ? 1 : -1;
            }
            else if (first < second) {
                return !orderByDescending ? -1 : 1;
            }
            else {
                return 0;
            }
        };
    };
    RxTagComponent.prototype.getTagModelSource = function (source) {
        var _this = this;
        var textPattern = this.keyValueProps[0].split(/#/g);
        var tags = new Array();
        source.forEach(function (t) {
            var text = '';
            textPattern.forEach(function (x) {
                if (x != "")
                    if (t[x] != undefined)
                        text += t[x];
                    else
                        text += x;
            });
            if ((t["status"] == undefined) || (t["status"] != undefined && t["status"] == true))
                tags.push(new TagModel(t[_this.keyValueProps[1]], text, false));
            else
                _this.inActiveSource.push(new TagModel(t[_this.keyValueProps[1]], text, false, true));
        });
        return tags;
    };
    RxTagComponent.prototype.getSelectedTags = function (source, tags) {
        var _this = this;
        this.selectedTags = new Array();
        var selectedSource = [];
        if (tags)
            String(tags).split(this.splitCharacter).forEach(function (v) {
                if (v != "") {
                    var baseId = v;
                    var result = source.filter(function (t) { return t.id == baseId; });
                    if (result.length > 0 && _this.selectedTags.filter(function (t) { return t.id == baseId; }).length === 0)
                        selectedSource.push(result[0]);
                    else {
                        result = _this.inActiveSource.filter(function (t) { return t.id == baseId; });
                        if (result.length > 0 && _this.selectedTags.filter(function (t) { return t.id == baseId; }).length === 0)
                            selectedSource.push(result[0]);
                    }
                }
            });
        return selectedSource;
    };
    RxTagComponent.prototype.setSelectedTags = function (source, tags) {
        var _this = this;
        this.selectedTags = new Array();
        if (tags)
            String(tags).split(this.splitCharacter).forEach(function (v) {
                if (v != "") {
                    var baseId = v;
                    var result = source.filter(function (t) { return t.id == baseId; });
                    if (result.length > 0 && _this.selectedTags.filter(function (t) { return t.id == baseId; }).length === 0)
                        _this.selectTag(result[0]);
                    else {
                        result = _this.inActiveSource.filter(function (t) { return t.id == baseId; });
                        if (result.length > 0 && _this.selectedTags.filter(function (t) { return t.id == baseId; }).length === 0)
                            _this.selectTag(result[0]);
                    }
                }
            });
    };
    RxTagComponent.prototype.setDropSource = function (source) {
        var _this = this;
        this.dropSource = new Array();
        source.forEach(function (t) { return _this.dropSource.push(t); });
    };
    RxTagComponent.prototype.applyFocus = function (tagSearch) {
        tagSearch.focus();
        this.focus = false;
    };
    RxTagComponent.prototype.reset = function () {
        this.setDropSource(this.mainSource);
        this.setSelectedTags(this.mainSource, "");
        this.propagateChange(undefined);
    };
    RxTagComponent.prototype.changeTagSource = function (source) {
        this.inActiveSource = new Array();
        var tagModels = this.getTagModelSource(source);
        this.setDropSource(tagModels);
        this.setSelectedTags(tagModels, this.getTagString());
    };
    RxTagComponent.prototype.showTag = function (tags, clearExisting) {
        var _this = this;
        if (tags && !this.limitExceded()) {
            if (clearExisting && tags.split(this.splitCharacter).length > parseInt(this.maxSelection)) {
                return;
            }
            this.selectedTags.forEach(function (tag) { return _this.dropSource.push(tag); });
            tags = clearExisting ? tags : this.getTagString() + this.splitCharacter + tags;
            this.setSelectedTags(this.dropSource, tags);
        }
    };
    RxTagComponent.prototype.clear = function () {
        var _this = this;
        this.isCalledFromWriteValue = false;
        this.selectedTags.forEach(function (t) { return _this.dropSource.push(t); });
        this.sortSource();
        this.selectedTags = new Array();
        this.updateFormValue();
    };
    RxTagComponent.prototype.selectAll = function () {
        var _this = this;
        var dropTags = new Array();
        this.dropSource.forEach(function (t) { return dropTags.push(t); });
        dropTags.forEach(function (t) { return _this.selectTag(t); });
    };
    RxTagComponent.prototype.getTagString = function () {
        var _this = this;
        var tagString = '';
        var selectCount = 0;
        this.selectedTags.forEach(function (t) {
            if ((selectCount === _this.selectedTags.length - 1)) {
                if (t.id == -1)
                    tagString += t.text;
                else
                    tagString += t.id;
            }
            else {
                if (t.id == -1)
                    tagString += t.text + _this.splitCharacter;
                else
                    tagString += t.id + _this.splitCharacter;
            }
            selectCount++;
        });
        return tagString;
    };
    RxTagComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    RxTagComponent.prototype.registerOnTouched = function () { };
    RxTagComponent.prototype.writeValue = function (value, fromNg) {
        if (fromNg === void 0) { fromNg = false; }
        if (value !== undefined)
            this.currentValue = value;
        if (this.selectedTags.length > 0) {
            this.isCalledFromWriteValue = true;
            this.ngAfterContentInit();
        }
        if (this.formControl && !fromNg)
            this.formControl.setValue(this.currentValue);
    };
    RxTagComponent.prototype.removeTag = function (tag) {
        if (!this.tagDisabled) {
            this.removed.emit(tag);
            var indexOf = this.selectedTags.indexOf(tag);
            this.selectedTags.splice(indexOf, 1);
            if (!tag.isRecordInvactive && tag.id != -1)
                if (this.isServerCalled || !this.lookup) {
                    this.dropSource.push(tag);
                    this.sortSource();
                }
            this.updateFormValue();
        }
    };
    RxTagComponent.prototype.getCloned = function (source) {
        var jObject = [];
        source.forEach(function (t) {
            jObject.push(t);
        });
        return jObject;
    };
    RxTagComponent.prototype.onFocus = function (event) {
        var _this = this;
        if ((!this.userSource && this.mainSource.length === 0 && this.lookup) || (this.autoComplete) || this.isObjectChanged) {
            if ((this.currentValue && this.currentValue.length >= this.minimumCharacterSearchLength) || (!this.autoComplete)) {
                var params_1 = [];
                if (this.params)
                    this.params.forEach(function (t) { return params_1.push(t); });
                if (this.autoComplete && this.currentValue) {
                    if (this.valueInQueryParams) {
                        if (!this.queryParams)
                            this.queryParams = {};
                        this.queryParams['q'] = this.currentValue;
                    }
                    else
                        params_1.push(this.currentValue);
                }
                this.isSpinner = true;
                this.get({ path: this.path, params: params_1, queryParams: this.queryParams }).subscribe(function (t) {
                    _this.userSource = t;
                    _this.mainSource = [];
                    _this.dropSource = [];
                    _this.setMainSource(t);
                    _this.selectedTags.forEach(function (t) {
                        if (_this.dropSource.length > 0) {
                            var indexOf = _this.dropSource.indexOf(t);
                            if (indexOf != -1)
                                _this.dropSource.splice(indexOf, 1);
                        }
                    });
                    _this.sortSource();
                    _this.setActiveTabClass();
                    _this.isSpinner = false;
                    _this.isObjectChanged = false;
                });
            }
        }
        else {
            var value = event.srcElement.value;
            var regex = new RegExp(this.removeDoubleBackslashes(value.toLocaleLowerCase()));
            this.dropSource = this.getCloned(this.itemTexts ? this.dropSource : this.mainSource).filter(function (t) { return regex.test(t.text.toLowerCase()); });
            this.selectedTags.forEach(function (t) {
                if (_this.dropSource.length > 0) {
                    var indexOf = _this.dropSource.indexOf(t);
                    if (indexOf != -1)
                        _this.dropSource.splice(indexOf, 1);
                }
            });
            this.sortSource();
            this.setActiveTabClass();
        }
    };
    RxTagComponent.prototype.onBlur = function (event) {
        var _this = this;
        if (this.timeOutId)
            window.clearTimeout(this.timeOutId);
        this.timeOutId = window.setTimeout(function () {
            if (_this.freeTextEnabled) {
                _this.enter(event.target);
            }
            _this.clearActiveTabClass();
            _this.changeScroll(0);
        }, 200);
    };
    RxTagComponent.prototype.removeDoubleBackslashes = function (input) {
        var separator = ['\\'];
        var result = "";
        var subResult = input.split(separator);
        for (var i = 0; i <= subResult.length - 1; i++) {
            if (subResult[i])
                result = i < subResult.length - 1 ? result + subResult[i] + "\\" : result + subResult[i];
        }
        return result;
    };
    RxTagComponent.prototype.onKeyup = function (event, scroller) {
        var _this = this;
        var value = event.srcElement.value;
        var regex = new RegExp(this.removeDoubleBackslashes(value.toLocaleLowerCase()));
        if (value !== null && event.keyCode !== 40 && event.keyCode !== 13 && event.keyCode !== 37) {
            if (this.autoComplete) {
                this.currentValue = value;
                this.onFocus(event);
            }
            else {
                this.dropSource = this.mainSource.filter(function (t) { return regex.test(t.text.toLowerCase()); });
                this.selectedTags.forEach(function (t) {
                    if (_this.dropSource.length > 0) {
                        var indexOf = _this.dropSource.indexOf(t);
                        if (indexOf != -1)
                            _this.dropSource.splice(indexOf, 1);
                    }
                });
                this.setActiveTabClass();
            }
        }
    };
    RxTagComponent.prototype.onKeydown = function (event, scroller) {
        if (event.keyCode === 40) {
            event.preventDefault();
            if (this.dropSource.length !== this.dropIndex) {
                if (this.dropIndex !== 0)
                    this.dropSource[this.dropIndex - 1].active = false;
                this.dropSource[this.dropIndex].active = true;
                (this.dropIndex !== this.dropSource.length - 1) ? this.dropIndex++ : 0;
                this.changeScroll();
                if (this.openDrop === "")
                    this.setActiveTabClass();
            }
        }
        else if (event.keyCode === 38) {
            event.preventDefault();
            this.dropSource[this.dropIndex].active = false;
            if (this.dropIndex !== 0)
                this.dropIndex--;
            this.dropSource[this.dropIndex].active = true;
            (this.dropIndex == 0) ? this.dropIndex++ : 0;
            this.changeScroll();
        }
        else if (event.keyCode === 13) {
            event.preventDefault();
            var selectedTag = this.dropSource.filter(function (t) { return t.active; });
            if (selectedTag.length > 0) {
                this.selectTag(selectedTag[0]);
                this.clearValue(event.srcElement);
            }
        }
    };
    RxTagComponent.prototype.limitExceded = function () {
        this.isLimitExceeded = !(parseInt(this.maxSelection) !== this.selectedTags.length);
        return this.isLimitExceeded;
    };
    RxTagComponent.prototype.setActiveTabClass = function () {
        if (this.limitExceded())
            this.maxSelectionMessage = this.maxSelectionMessage.replace('#maxSelection#', this.maxSelection);
        this.activeTag = "chosen-container-active";
        this.openDrop = "chosen-with-drop";
    };
    RxTagComponent.prototype.changeScroll = function (offset) {
        var scrollerElement = document.getElementById(String(this.selectId));
        if (scrollerElement) {
            var childElement = scrollerElement.getElementsByClassName("activeTag")[0];
            if (childElement != undefined)
                scrollerElement.scrollTop = offset === 0 ? 0 : childElement.offsetTop - 50;
        }
    };
    RxTagComponent.prototype.enter = function (targetElement) {
        if (this.freeTextEnabled) {
            var value = targetElement.value;
            if (value) {
                var tagModel = new TagModel(-1, value, true);
                var result = this.selectedTags.filter(function (t) { return t.text.toLowerCase() == value.toLowerCase(); })[0];
                if (!result) {
                    this.selectedTags.push(tagModel);
                    this.updateFormValue();
                }
                this.clearValue(targetElement);
            }
        }
    };
    RxTagComponent.prototype.onClick = function (tag, tagSearchElement) {
        this.selectTag(tag);
        this.clearValue(tagSearchElement);
    };
    RxTagComponent.prototype.selectTag = function (tag) {
        this.added.emit(tag);
        tag.active = false;
        var indexOf = this.dropSource.indexOf(tag);
        this.dropSource.splice(indexOf, 1);
        this.selectedTags.push(tag);
        this.clearActiveTabClass();
        if (!this.isCalledFromWriteValue)
            this.updateFormValue();
        this.isCalledFromWriteValue = false;
    };
    RxTagComponent.prototype.updateFormValue = function () {
        var _this = this;
        var value = "";
        var count = 0;
        this.selectedTags.forEach(function (t) {
            if (count === 0) {
                if (t.id == -1)
                    value += t.text;
                else
                    value += t.id;
            }
            else {
                if (t.id == -1)
                    value += _this.splitCharacter + t.text;
                else
                    value += _this.splitCharacter + t.id;
            }
            count++;
        });
        if (!this.isServerCalled)
            this.currentValue = value;
        this.propagateChange(this.selectedTags.length == 0 ? undefined : value);
        if (this.formControl)
            this.formControl.patchValue(value);
    };
    RxTagComponent.prototype.onMouseover = function (tag) {
        this.dropSource.forEach(function (t) { return t.active = false; });
        tag.active = true;
    };
    RxTagComponent.prototype.clearValue = function (element) {
        element.value = "";
        //this.renderer.invokeElementMethod(element, "focus", []);
    };
    RxTagComponent.prototype.clearActiveTabClass = function () {
        this.activeTag = "";
        this.openDrop = "";
        this.dropIndex = 0;
        this.dropSource.forEach(function (tag) { return tag.active = false; });
    };
    RxTagComponent.prototype.subscribeFormControl = function () {
        var _this = this;
        this.currentFormControl.statusChanges.subscribe(function (t) {
            _this.isInValid = t === "INVALID";
        });
    };
    RxTagComponent.prototype.validate = function (formControl) {
        if (!this.currentFormControl) {
            this.currentFormControl = formControl;
            this.subscribeFormControl();
        }
        return null;
    };
    RxTagComponent.prototype.ngOnDestroy = function () {
        var tString = '';
        this.selectedTags.forEach(function (t) { return tString += t.id; });
        this.selectedTags = [];
        this.mainSource = [];
    };
    var RxTagComponent_1;
    RxTagComponent.ctorParameters = function () { return [
        { type: ElementRef },
        { type: Renderer2 }
    ]; };
    __decorate([
        ViewChild('tagSearch', { static: false })
    ], RxTagComponent.prototype, "selectSearch", void 0);
    __decorate([
        Output()
    ], RxTagComponent.prototype, "removed", void 0);
    __decorate([
        Output()
    ], RxTagComponent.prototype, "added", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "mainClass", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "freeTextEnabled", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "controlTabIndex", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "formControl", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "isSort", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "params", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "minimumCharacterSearchLength", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "onlySelectedValueSource", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "autoComplete", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "path", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "queryParams", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "placeholder", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "excludePlaceholder", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "source", null);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "tagDisabled", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "maxSelection", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "keyValueProps", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "focus", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "valueInQueryParams", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "itemTexts", void 0);
    __decorate([
        Input()
    ], RxTagComponent.prototype, "text", null);
    RxTagComponent = RxTagComponent_1 = __decorate([
        Component({
            selector: 'rx-tag',
            template: "<div class=\"chosen-container chosen-container-multi  {{openDrop}} {{activeTag}} \" [class.rxMessage-control-element]=\"!isInValid\" style=\"width: 100%;\" title=\"\">\r\n    <ul class=\"chosen-choices form-control rounded-0\">\r\n        <li class=\"search-choice\" *ngFor=\"let tag of selectedTags\">\r\n            <span>{{tag.text}}</span>\r\n            <i class=\"close \" *ngIf=\"!tagDisabled\" (click)=\"removeTag(tag)\">&times;</i>\r\n        </li>\r\n        <li class=\"search-field\">\r\n            <input [id]=\"searchId\" [tabindex]=\"controlTabIndex\" [class]=\"mainClass\" [placeholder]=\"selectedTags.length == 0 ? placeholder : ''\" type=\"text\" #tagSearch [disabled]=\"tagDisabled\" (click)=\"onFocus($event)\" (focus)=\"onFocus($event)\" (blur)=\"onBlur($event)\" (keydown)=\"onKeydown($event,scroller)\" (keydown.enter)=\"enter($event.target)\" (keyup)=\"onKeyup($event,scroller)\" value=\"\" class=\"\" autocomplete=\"off\">\r\n        </li>\r\n    </ul>\r\n    <div class=\"chosen-drop\" #scroller>\r\n        <ul class=\"chosen-results\" [id]=\"selectId\" *ngIf=\"!isLimitExceeded\">\r\n            <li class=\"active-result\" *ngFor=\"let tag of dropSource \" (click)=\"onClick(tag,tagSearch)\" (mouseover)=\"onMouseover(tag)\" [class.highlighted]=\"tag.active\" [class.activeTag]=\"tag.active\">{{tag.text}}</li>\r\n        </ul>\r\n        <ul class=\"chosen-results\" *ngIf=\"isLimitExceeded\">\r\n            <li class=\"active-result\">{{maxSelectionMessage}}</li>\r\n        </ul>\r\n    </div>\r\n</div>\r\n",
            providers: [
                { provide: NG_VALUE_ACCESSOR, useExisting: forwardRef(function () { return RxTagComponent_1; }), multi: true },
                { provide: NG_VALIDATORS, useExisting: forwardRef(function () { return RxTagComponent_1; }), multi: true }
            ],
            exportAs: 'tag'
        })
    ], RxTagComponent);
    return RxTagComponent;
}(RxHttp));
var RxTagModule = /** @class */ (function () {
    function RxTagModule() {
    }
    RxTagModule = __decorate([
        NgModule({
            imports: [CommonModule, FormsModule, ReactiveFormsModule],
            exports: [RxTagComponent],
            declarations: [RxTagComponent]
        })
    ], RxTagModule);
    return RxTagModule;
}());

/**
 * Generated bundle index. Do not edit.
 */

export { RxTagComponent, RxTagModule };
//# sourceMappingURL=rxweb-angular-tag.js.map
